﻿using System;

/// <summary>
/// The basic creature class, this will be inherited from for all other
/// monsters and players in the game
/// </summary>

public enum direction { NORTH = -1, SOUTH = 1, EAST = 1, WEST = -1};

public class Creature
{
    int hp;
    int mp;
    int basearmor;
    int basepower;
    int level;
    int xpos;
    int ypos;
    direction facing;

    public Creature()
    {}

    public direction FACE
    { set { facing = value; }
      get { return facing; }
    }
    public int HP
    {   set{ hp = value;}
        get{ return hp;}
    }
    public int MP
    {
        set { mp = value; }
        get { return mp; }
    }
    public int ARMOR
    {
        set { basearmor = value; }
        get { return basearmor; }
    }
    public int POWER
    {
        set { basepower = value; }
        get { return basepower; }
    }
    public int LVL
    {
        set { level = value; }
        get { return level; }
    }
    public int XPOS
    {
        set { xpos = value; }
        get { return xpos; }
    }
    public int YPOS
    {
        set { ypos = value; }
        get { return ypos; }
    }
    public void move(direction d)
    {
        if (d == NORTH)
        {
            setpos(XPOS, (YPOS - 1));
            FACE = NORTH;
        }
        if (d == SOUTH)
        {
            setpos(XPOS, (YPOS + 1));
            FACE = SOUTH;
        }
        if (d == EAST)
        {
            setpos((XPOS + 1), YPOS);
            FACE = EAST;
        }
        if (d == WEST)
        {
            setpos((XPOS - 1), YPOS);
            FACE = WEST;
        }
    }
    public void setpos(int x, int y)
    {//need to add a check to make sure the spot being moved to exists
        XPOS = x;
        YPOS = y;
    }
    public void turn(direction d)
    {
        FACE = d;
    }
}

public class player : Creature
{
    int experience;
    int tp;//talent points for upgrading talent trees
    public player()
    {
        HP = 30;
        MP = 20;
        ARMOR = 10;
        POWER = 10;
        LVL = 1;
        experience = 0;
        tp = 1;
        FACE = NORTH;
    }
    public void levelUP()
    {
        LVL += 1;
        HP += 10;
        MP += 10;
        ARMOR += 5;
        POWER += 5;
        tp += 1;
    }
}

public class Monster : Creature
{
    public Monster()
    {
        HP = 30;
        MP = 50;
        ARMOR = 10;
        POWER = 10;
        LVL = 1;
        FACE = NORTH;
    }
    public void AI(player enemy)
    {
        Random rand = new Random();
        int directional = (int)rand.Next(4);
        direction d;
        switch (directional)
        {
            case 0:
                d = NORTH;
                break;
            case 1:
                d = SOUTH;
                break;
            case 2:
                d = EAST;
                break;
            case 3:
                d = WEST;
                break;
            default:
                d = SOUTH;
        }
        if (abs(enemy.YPOS - this.YPOS) < 5 || abs(enemy.XPOS - this.XPOS) < 5)
        {//if the player is within 5 squares of the monster persue the player
            if ((abs(enemy.YPOS - this.YPOS) > abs(enemy.XPOS - this.XPOS)) && abs(enemy.YPOS - this.YPOS) != 1)
            {//if there is more of a difference in y position move in a y position
                if (enemy.YPOS < this.YPOS)
                { 
                    this.move(NORTH);
                }
                else
                {
                    this.move(SOUTH);
                }
            }
            else if ((abs(enemy.YPOS - this.YPOS) < abs(enemy.XPOS - this.XPOS)) && abs(enemy.XPOS - this.XPOS) != 1)
            {//if the x pos is more of a difference move in an x direction
                if (enemy.XPOS < this.XPOS)
                {
                    this.move(WEST);
                }
                else
                {
                    this.move(EAST);
                }
            }
            else if (abs(enemy.YPOS - this.YPOS) == abs(enemy.XPOS - this.XPOS))
            {//this one will have them both at the same and it will move to a random
                //direction toward the player
                //also when the monster is diagonal by 1 from the player this will make it
                //walk next to them to hit them
                this.move(d);
            }
            else
            {//attack otherwise
                //change facing to the player, attack the player with a random ability or
                //a normal meelee attack
                
            }
        }
        else
        {//if the player is not in range try to move in a random direction until you do move
            this.move(d);
        }
    }
}