using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
//some sprites from 
//http://spritedatabase.net/display.php?object=4928
//http://fireheart-vadis.blogspot.com/2009_09_01_archive.html
//http://charas-project.net/resources.php?wa=0&lang=en&area=16&howmany=all&fsearch
////////////////
/*
playersprite spritesheet = 62 width per spriteframe 64 height per spriteframe 
finalboss spritesheet = 32 width 57 height per spriteframe
 
*/
namespace monstertower
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //Texture2D charactersprite;
        Vector2 position = new Vector2(0, 0);

        public Texture2D ringsTexture;//player's texture facing south
        public Texture2D ringsTexture2;//north
        public Texture2D ringsTexture3;//east
        public Texture2D ringsTexture4;//west

        Vector2 ringsPosition = new Vector2(87 + 240, 87 + 640);//ring intial position
        const float ringsSpeed = 6;
        Point ringsFrameSize = new Point(63, 64);
        Point ringsCurrentFrame = new Point(0, 0);
        Point ringsSheetSize = new Point(3, 1);
        int ringsTimeSinceLastFrame = 0;
        int ringsMillisecondsPerFrame = 200;

        Texture2D background;
        Vector2 backpos = new Vector2(0, 0);

        public Texture2D bosssprite;
        public Texture2D bossspriteN;
        public Texture2D bossspriteE;
        public Texture2D bossspriteW;

        Vector2 bosspos = new Vector2(105 + 240, 12 + 0);
        const float bossspeed = 6;
        Point bossFrameSize = new Point(32, 57);
        Point bossCurrentFrame = new Point(0, 57);
        Point bossSheetSize = new Point(6, 1);
        int bossTimeSinceLastFrame = 0;
        int bossMillisecondsPerFrame = 150;

        Creature playerchar;
        Monster boss;
        public int[,] map;

        KeyboardState oldState;
        GamePadState oldgamepadstate;

        SpriteFont font;//font object
        bool helpinfo;
        bool xboxcheck;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.PreferredBackBufferWidth = 800;
            graphics.PreferredBackBufferHeight = 800;


        }  

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
            oldState = Keyboard.GetState();
            oldgamepadstate = GamePad.GetState(PlayerIndex.One);
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            ringsTexture = Content.Load<Texture2D>(@"southfacing");
            ringsTexture2 = Content.Load<Texture2D>(@"northtfacing");
            ringsTexture3 = Content.Load<Texture2D>(@"eastfacing");
            ringsTexture4 = Content.Load<Texture2D>(@"westfacing");
            background = Content.Load<Texture2D>(@"floor5map80by80sizetiles");
            bosssprite = Content.Load<Texture2D>(@"bosssprite");
            bossspriteN = Content.Load<Texture2D>(@"bossspriteN");
            bossspriteE = Content.Load<Texture2D>(@"bossspriteE");
            bossspriteW = Content.Load<Texture2D>(@"bossspriteW");
            font = Content.Load<SpriteFont>(@"SpriteFont1");

            playerchar = new player(ringsTexture, ringsTexture2, ringsTexture3, ringsTexture4);
            boss = new Monster(bosssprite, bossspriteN, bossspriteE, bossspriteW);
            map = new int[12, 12];
            //map will store information about where objects are and where you can move/cant move
            for (int i = 0; i < 12; i++)
            {//the following fills map with the proper info
                for (int j = 0; j < 12; j++)
                {
                    map[i, j] = 1;
                }
            }
            for (int j = 0; j < 12; j++)
            {
                map[11, j] = 0;
            }
            for (int j = 0; j < 12; j++)
            {
                map[j, 11] = 0;
            }
            for (int j = 0; j < 12; j++)
            {
                map[j, 0] = 0;
            }
            for (int j = 0; j < 12; j++)
            {
                map[0, j] = 0;
            }
            //these are the specific squares you cant move
            map[1, 1] = 0;
            map[1, 10] = 0;
            map[10, 1] = 0;
            map[10, 10] = 0;
            map[5, 10] = -1;
            map[5, 1] = -1;
            //the following bools will be for the helpscreen
            helpinfo = true;//showing helpscreen if true
            xboxcheck = false;//showing the helpscreen for xbox players if true
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // player spritesheet logic
            ringsTimeSinceLastFrame += gameTime.ElapsedGameTime.Milliseconds;
            if (ringsTimeSinceLastFrame > ringsMillisecondsPerFrame)
            {
                ringsTimeSinceLastFrame -= ringsMillisecondsPerFrame;

                ++ringsCurrentFrame.X;
                if (ringsCurrentFrame.X >= ringsSheetSize.X)
                {
                    ringsCurrentFrame.X = 0;
                    ++ringsCurrentFrame.Y;
                    if (ringsCurrentFrame.Y >= ringsSheetSize.Y)
                        ringsCurrentFrame.Y = 0;
                }
            }
            //boss spritesheet logic
            bossTimeSinceLastFrame += gameTime.ElapsedGameTime.Milliseconds;
            if (bossTimeSinceLastFrame > bossMillisecondsPerFrame)
            {
                bossTimeSinceLastFrame -= bossMillisecondsPerFrame;

                ++bossCurrentFrame.X;
                if (bossCurrentFrame.X >= bossSheetSize.X)
                {
                    bossCurrentFrame.X = 0;
                    ++bossCurrentFrame.Y;
                    if (bossCurrentFrame.Y >= bossSheetSize.Y)
                        bossCurrentFrame.Y = 0;
                }
            }





            ////////////////////////////////////////////////////////////////////////////////////////////////////////
            KeyboardState keyboardState = Keyboard.GetState();
            GamePadState gamepadstate = GamePad.GetState(PlayerIndex.One);
            //oldgamepadstate = gamepadstate;
            //control logic here, pretty simple stuff
            if(keyboardState.IsKeyDown(Keys.V) && !oldState.IsKeyDown(Keys.V))
            {
                if (helpinfo == false)
                {
                    helpinfo = true;
                }
                else 
                {
                    helpinfo = false;
                }
            }
            else if ((gamepadstate.Buttons.Y.Equals(ButtonState.Pressed) && !oldgamepadstate.Buttons.Y.Equals(ButtonState.Pressed)))
            {
                if (helpinfo == false)
                {
                    helpinfo = true;
                    xboxcheck = true;
                }
                else
                {
                    helpinfo = false;
                    xboxcheck = false;
                }
            }
            else if (playerchar.Currenthp > 0 && boss.Currenthp > 0)
            {
                if ((keyboardState.IsKeyDown(Keys.Left) && !oldState.IsKeyDown(Keys.Left)) || (gamepadstate.DPad.Left.Equals(ButtonState.Pressed) && !oldgamepadstate.DPad.Left.Equals(ButtonState.Pressed)))
                {

                    //playerchar.monsterpic = ringsTexture4;
                    playerchar.turn(direction.WEST);//turn function will change out the spritesheet image being looked at so that you
                    //see the character in its turned position
                    if (playerchar.move(direction.WEST, map))
                    {
                        boss.AI(playerchar, map);
                    }
                }
                else if ((keyboardState.IsKeyDown(Keys.Right) && !oldState.IsKeyDown(Keys.Right)) || (gamepadstate.DPad.Right.Equals(ButtonState.Pressed) && !oldgamepadstate.DPad.Right.Equals(ButtonState.Pressed)))
                {

                    //playerchar.monsterpic = ringsTexture3;
                    playerchar.turn(direction.EAST);
                    if (playerchar.move(direction.EAST, map))
                    {
                        boss.AI(playerchar, map);
                    }
                }
                else if ((keyboardState.IsKeyDown(Keys.Up) && !oldState.IsKeyDown(Keys.Up)) || (gamepadstate.DPad.Up.Equals(ButtonState.Pressed) && !oldgamepadstate.DPad.Up.Equals(ButtonState.Pressed)))
                {

                    //playerchar.monsterpic = ringsTexture2;
                    playerchar.turn(direction.NORTH);
                    if (playerchar.move(direction.NORTH, map))
                    {
                        boss.AI(playerchar, map);
                    }
                }
                else if ((keyboardState.IsKeyDown(Keys.Down) && !oldState.IsKeyDown(Keys.Down)) || (gamepadstate.DPad.Down.Equals(ButtonState.Pressed) && !oldgamepadstate.DPad.Down.Equals(ButtonState.Pressed)))
                {

                    //playerchar.monsterpic = ringsTexture;
                    playerchar.turn(direction.SOUTH);
                    if (playerchar.move(direction.SOUTH, map))
                    {
                        boss.AI(playerchar, map);
                    }
                }
                else if ((keyboardState.IsKeyDown(Keys.Space) && !oldState.IsKeyDown(Keys.Space)) || (gamepadstate.Buttons.A.Equals(ButtonState.Pressed) && !oldgamepadstate.Buttons.A.Equals(ButtonState.Pressed)))
                {
                    playerchar.attack(boss);
                    boss.AI(playerchar, map);
                }
                else if ((keyboardState.IsKeyDown(Keys.B) && !oldState.IsKeyDown(Keys.B)) || (gamepadstate.Buttons.B.Equals(ButtonState.Pressed) && !oldgamepadstate.Buttons.B.Equals(ButtonState.Pressed)))
                {
                    if (playerchar.Currentmp >= 5)
                    {
                        playerchar.Heal();
                        boss.AI(playerchar, map);
                    }
                }
                else if ((keyboardState.IsKeyDown(Keys.Enter) && !oldState.IsKeyDown(Keys.Enter)) || (gamepadstate.Buttons.Start.Equals(ButtonState.Pressed) && !oldgamepadstate.Buttons.Start.Equals(ButtonState.Pressed)))
                {
                    Exit();
                }
            }
            else
            {
                if ((keyboardState.IsKeyDown(Keys.Enter) && !oldState.IsKeyDown(Keys.Enter)) || (gamepadstate.Buttons.Start.Equals(ButtonState.Pressed) && !oldgamepadstate.Buttons.Start.Equals(ButtonState.Pressed)))
                {
                    Exit();
                }
            }
            
            oldgamepadstate = gamepadstate;
            oldState = keyboardState;
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>


        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            // TODO: Add your drawing code here


            spriteBatch.Begin();//SpriteBlendMode.AlphaBlend,
            //SpriteSortMode.FrontToBack, SaveStateMode.None);

            //Draw the rings
            //if (gameTime.IsRunningSlowly == false)//This checks if frame rate is running well enough for game to work
            //{

            spriteBatch.Draw(background, backpos, Color.White);//drawing floor/background
            //displaying the boss and players currenthp
            spriteBatch.DrawString(font, "PlayerHP: " + playerchar.Currenthp.ToString() + "/" + playerchar.HP, new Vector2(0,0), Color.White, 0.0F, new Vector2(0, 0), 1F, SpriteEffects.None, .3F);
            spriteBatch.DrawString(font, "PlayerMP: " + playerchar.Currentmp.ToString() + "/" + playerchar.MP, new Vector2(0, 15), Color.White, 0.0F, new Vector2(0, 0), 1F, SpriteEffects.None, .3F);
            if (playerchar.Currenthp > 0)
            {//whils the player hasn't died this will display
                spriteBatch.Draw(playerchar.gettex(), playerchar.position,
                new Rectangle(ringsCurrentFrame.X * ringsFrameSize.X,
                    ringsCurrentFrame.Y * ringsFrameSize.Y,
                    ringsFrameSize.X,
                    ringsFrameSize.Y),
                    Color.White, 0, Vector2.Zero,
                    1, SpriteEffects.None, .2F);
            }
            else
            {
                if(boss.Currenthp > 0)
                    spriteBatch.DrawString(font, "YOU LOSE!" , new Vector2(50,400), Color.Aqua, 0.0F, new Vector2(0,0), 5F, SpriteEffects.None, .3F);
                else
                    spriteBatch.DrawString(font, "IT'S A TIE!", new Vector2(50, 400), Color.Aqua, 0.0F, new Vector2(0, 0), 5F, SpriteEffects.None, .3F);
            }

            spriteBatch.DrawString(font, "BossHP: " + boss.Currenthp.ToString() + "/" + boss.HP, new Vector2(0, 30), Color.White, 0.0F, new Vector2(0, 0), 1F, SpriteEffects.None, .3F);
            if (boss.Currenthp > 0)
            {//while the boss hasn't died this will display
                spriteBatch.Draw(boss.gettex(), boss.getvec(),
                new Rectangle(bossCurrentFrame.X * bossFrameSize.X,
                    bossCurrentFrame.Y * bossFrameSize.Y,
                    bossFrameSize.X,
                    bossFrameSize.Y),
                    Color.White, 0, Vector2.Zero,
                    1, SpriteEffects.None, .1F);
            }
            else 
            {
                if(playerchar.Currenthp > 0)
                   spriteBatch.DrawString(font, "YOU WIN!", new Vector2(50,400), Color.Aqua, 0.0F, new Vector2(0,0), 5F, SpriteEffects.None, .3F);
                else
                   spriteBatch.DrawString(font, "IT'S A TIE!", new Vector2(50, 400), Color.Aqua, 0.0F, new Vector2(0, 0), 5F, SpriteEffects.None, .3F);
            }

            if (helpinfo)
            {
                if (xboxcheck)
                {//xbox help info
                    spriteBatch.DrawString(font, "Up Dpad to move North", new Vector2(0, 100), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Down Dpad to move South", new Vector2(0, 140), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Right Dpad to move East", new Vector2(0, 180), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Left Dpad to move West", new Vector2(0, 220), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "A Button to attack", new Vector2(0, 260), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "B Button to heal", new Vector2(0, 300), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Start Button to exit", new Vector2(0, 340), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Y Button to show/hide help display", new Vector2(0, 380), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                }
                else 
                {//normal windows/keyboard help info
                    spriteBatch.DrawString(font, "Up Key to move North", new Vector2(0, 100), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Down Key to move South", new Vector2(0, 140), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Right Key to move East", new Vector2(0, 180), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Left Key to move West", new Vector2(0, 220), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Space Bar to attack", new Vector2(0, 260), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "B Key to heal", new Vector2(0, 300), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "Return Key to exit", new Vector2(0, 340), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "V Key to show/hide help display", new Vector2(0, 380), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                    spriteBatch.DrawString(font, "[XBOX] Y Button to show/hide help display", new Vector2(0, 460), Color.Aqua, 0.0F, new Vector2(0, 0), 2F, SpriteEffects.None, .3F);
                }
            }

            spriteBatch.End();
            base.Draw(gameTime);

            //spriteBatch.Draw(ringsTexture, position, new Rectangle(0, 0, 62, 64), Color.White, 0.0f, new Vector2(0,0),1, SpriteEffects.None, 0.0f);
        }
    }

    /// <summary>
    /// The basic creature class, this will be inherited from for all other
    /// monsters and players in the game
    /// </summary>

    public enum direction { NORTH, SOUTH, EAST, WEST };

    public class Creature
    {//base class for players and monsters
        int hp;
        int mp;
        int currenthp;
        int currentmp;
        int basearmor;
        int basepower;
        int level;
        int xpos;
        int ypos;
        direction facing;
        //Vector2 Position;
        Texture2D Monsterpic;
        Texture2D Monsterpic1;
        Texture2D Monsterpic2;
        Texture2D Monsterpic3;
        Texture2D Monsterpic4;

        public Vector2 position { set; get; }
        public Texture2D monsterpic { set { Monsterpic = value; } get { return Monsterpic; } }
        public Texture2D monsterpic1 { set { Monsterpic1 = value; } get { return Monsterpic1; } }
        public Texture2D monsterpic2 { set { Monsterpic2 = value; } get { return Monsterpic2; } }
        public Texture2D monsterpic3 { set { Monsterpic3 = value; } get { return Monsterpic3; } }
        public Texture2D monsterpic4 { set { Monsterpic4 = value; } get { return Monsterpic4; } }

        public int Currenthp{set{ currenthp = value;}get{return currenthp;}}
        public int Currentmp { set { currentmp = value; } get { return currentmp; } }
        
        public Vector2 getvec()
        {
            return position;
        }

        public Texture2D gettex()
        {
            return monsterpic;
        }

        public Creature()
        {

        }
        
        public direction FACE
        {
            set { facing = value; }
            get { return facing; }
        }
        public int HP
        {
            set { hp = value; }
            get { return hp; }
        }
        public int MP
        {
            set { mp = value; }
            get { return mp; }
        }
        public int ARMOR
        {
            set { basearmor = value; }
            get { return basearmor; }
        }
        public int POWER
        {
            set { basepower = value; }
            get { return basepower; }
        }
        public int LVL
        {
            set { level = value; }
            get { return level; }
        }
        public int XPOS
        {
            set { xpos = value; }
            get { return xpos; }
        }
        public int YPOS
        {
            set { ypos = value; }
            get { return ypos; }
        }
        public bool move(direction d, int[,] map)
        {//basic move function that all objects use for moving
            if (d == direction.NORTH)
            {
                turn(direction.NORTH);
                if (map[XPOS, (YPOS - 1)] != 0 && map[XPOS, (YPOS - 1)] != -1)
                {//-1 will be a spot with a player or monster on it, 0 will be a missing square
                    map[XPOS, YPOS] = 1;
                    setpos(XPOS, (YPOS - 1));
                    map[XPOS, YPOS] = -1;
                    position = new Vector2(position.X, position.Y - 80);
                    return true;
                }
                return false;
            }
            else if (d == direction.SOUTH)
            {
                turn(direction.SOUTH);
                if (map[XPOS, (YPOS + 1)] != 0 && map[XPOS, (YPOS + 1)] != -1)
                {
                    map[XPOS, YPOS] = 1;
                    setpos(XPOS, (YPOS + 1));
                    map[XPOS, YPOS] = -1;
                    position = new Vector2(position.X, position.Y + 80);
                    return true;
                }
                return false;
            }
            else if (d == direction.EAST)
            {
                turn(direction.EAST);
                if (map[(XPOS + 1), YPOS] != 0 && map[(XPOS + 1), YPOS] != -1)
                {
                    map[XPOS, YPOS] = 1;
                    setpos((XPOS + 1), YPOS);
                    map[XPOS, YPOS] = -1;
                    position = new Vector2(position.X + 80, position.Y);
                    return true;
                }
                return false;
            }
            else if (d == direction.WEST)
            {
                turn(direction.WEST);
                if (map[(XPOS - 1), YPOS] != 0 && map[(XPOS - 1), YPOS] != -1)
                {
                    map[XPOS, YPOS] = 1;
                    setpos((XPOS - 1), YPOS);
                    map[XPOS, YPOS] = -1;
                    position = new Vector2(position.X - 80, position.Y);
                    return true;
                }
                return false;
            }
            else
            {
                return false;
            }
        }
        public void setpos(int x, int y)
        {//moves the object to the set location (only affects the map matrix in the long run
            XPOS = x;
            YPOS = y;
        }
        public virtual void turn(direction d)
        {//will be overwritten for player and monster
            FACE = d;

        }
        public virtual void attack(Creature enemy)
        {}//overwritten for all objects
        public virtual void Heal()
        { }//only the player gets this
    }

    public class player : Creature
    {
        int experience;
        int tp;//talent points for upgrading talent trees
        public player(Texture2D pic, Texture2D pic2, Texture2D pic3, Texture2D pic4)
        {
            HP = 70;
            MP = 60;
            Currenthp = 70;
            Currentmp = 60;
            ARMOR = 30;
            POWER = 45;
            LVL = 5;
            experience = 0;
            tp = 6;
            FACE = direction.SOUTH;
            position = new Vector2(87 + 240, 87 + 640);
            monsterpic = pic;
            monsterpic1 = pic;//south
            monsterpic2 = pic2;//north
            monsterpic3 = pic3;//east
            monsterpic4 = pic4;//west
            XPOS = 5;
            YPOS = 10;
        }
        public void levelUP()
        {//was going to use this but time constraints have stripped my project idea allot
            LVL += 1;
            HP += 10;
            MP += 10;
            ARMOR += 5;
            POWER += 5;
            tp += 1;
        }
        public void gainexp(Monster defeated)
        {//was going to use this but time constraints have stripped my project idea allot
            this.experience += (defeated.LVL * 10) / this.LVL;
            if (this.experience >= 100)
            {
                experience -= 100;
                this.levelUP();
            }
        }

        public override void attack(Creature enemy)
        {
            int xdif = enemy.XPOS - this.XPOS;
            int ydif = enemy.YPOS - this.YPOS;
            int damage = this.POWER - enemy.ARMOR;
            if(damage < 1)
            {
                damage = 1;
            }

            if (ydif == 0 && xdif == 1)
            {//the enemy is to the EAST
                if (this.FACE == direction.EAST)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == 0 && xdif == -1))
            {//the enemy is to the  WEST
                if (this.FACE == direction.WEST)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == 1 && xdif == 0))
            {//the enemy is to the SOUTH
                if (this.FACE == direction.SOUTH)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == -1 && xdif == 0))
            {//the enemy is to the NORTH
                if (this.FACE == direction.NORTH)
                {
                    enemy.Currenthp -= damage;
                }
            }
        }
        public override void turn(direction d)
        {
            FACE = d;
            if(d == direction.WEST)
            {
                monsterpic = monsterpic4;
            }
            else if(d == direction.EAST)
            {
                monsterpic = monsterpic3;
            }
            else if(d == direction.SOUTH)
            {
                monsterpic = monsterpic1;
            }
            else if(d == direction.NORTH)
            {
                monsterpic = monsterpic2;
            }
            else
            {
                monsterpic = monsterpic;
            }
        }
        public override void Heal()
        {
            if (Currentmp >= 5)
            {
                this.Currenthp += (this.LVL * 5);
                this.Currentmp -= 5;
                if (this.Currenthp > this.HP)
                {
                    this.Currenthp = this.HP;
                }
            }
        }
    }

    public class Monster : Creature
    {
        public Monster(Texture2D pic, Texture2D pic2, Texture2D pic3, Texture2D pic4)
        {
            HP = 200;
            MP = 50;
            Currenthp = 200;
            Currentmp = 50;
            ARMOR = 35;
            POWER = 40;
            LVL = 5;
            FACE = direction.SOUTH;
            position = new Vector2(105 + 240, 12 + 0);
            monsterpic = pic;
            monsterpic1 = pic;
            monsterpic2 = pic2;
            monsterpic3 = pic3;
            monsterpic4 = pic4;
            XPOS = 5;
            YPOS = 1;
        }
        public void AI(Creature enemy, int[,] map)
        {//the creature AI, if the player is more then 5 squares away ignore him and move randomly(it does it but doesnt look much like it)
            //or if the player is with 5 squares pursue him and kill him when close
            Random rand = new Random();
            bool waste;

            int directional = (int)rand.Next(4);
            direction d;
            switch (directional)
            {
                case 0:
                    d = direction.NORTH;
                    break;
                case 1:
                    d = direction.SOUTH;
                    break;
                case 2:
                    d = direction.EAST;
                    break;
                case 3:
                    d = direction.WEST;
                    break;
                default:
                    d = direction.SOUTH;
                    break;
            }

            if (Math.Abs(enemy.YPOS - this.YPOS) < 5 || Math.Abs(enemy.XPOS - this.XPOS) < 5)
            {//if the player is within 5 squares of the monster persue the player
                if ((Math.Abs(enemy.YPOS - this.YPOS) > Math.Abs(enemy.XPOS - this.XPOS)) && Math.Abs(enemy.YPOS - this.YPOS) > 1)
                {//if there is more of a difference in y position move in a y position
                    if (enemy.YPOS < this.YPOS)
                    {
                        waste = this.move(direction.NORTH, map);
                    }
                    else
                    {
                        waste = this.move(direction.SOUTH, map);
                    }
                }
                else if ((Math.Abs(enemy.YPOS - this.YPOS) < Math.Abs(enemy.XPOS - this.XPOS)) && Math.Abs(enemy.XPOS - this.XPOS) > 1)
                {//if the x pos is more of a difference move in an x direction
                    if (enemy.XPOS < this.XPOS)
                    {
                        waste = this.move(direction.WEST, map);
                    }
                    else
                    {
                        waste = this.move(direction.EAST, map);
                    }
                }
                else if (Math.Abs(enemy.YPOS - this.YPOS) == Math.Abs(enemy.XPOS - this.XPOS))
                {//this one will have them both at the same and it will move to a random
                    //direction toward the player
                    //also when the monster is diagonal by 1 from the player this will make it
                    //walk next to them to hit them
                    directional = (int)rand.Next(2);
                    if ((enemy.YPOS - this.YPOS) < 0 && (enemy.XPOS - this.XPOS) < 0)
                    {
                        if(directional == 0)
                            d = direction.NORTH;
                        else
                            d = direction.WEST;
                    }
                    else if ((enemy.YPOS - this.YPOS) > 0 && (enemy.XPOS - this.XPOS) < 0)
                    {
                        if (directional == 0)
                            d = direction.WEST;
                        else
                            d = direction.SOUTH;
                    }
                    if ((enemy.YPOS - this.YPOS) > 0 && (enemy.XPOS - this.XPOS) > 0)
                    {
                        if (directional == 0)
                            d = direction.EAST;
                        else
                            d = direction.SOUTH;
                    }
                    else if ((enemy.YPOS - this.YPOS) < 0 && (enemy.XPOS - this.XPOS) > 0)
                    {
                        if (directional == 0)
                            d = direction.EAST;
                        else
                            d = direction.NORTH;
                    }

                    waste = this.move(d, map);
                }
                else
                {//attack otherwise
                    //change facing to the player, attack the player with a random ability or
                    //a normal meelee attack
                    //add change facing logic here
                    int xdif = enemy.XPOS - this.XPOS;
                    int ydif = enemy.YPOS - this.YPOS;

                    if (ydif == 0 && xdif == 1)
                    {//the enemy is to the EAST
                        turn(direction.EAST);
                    }
                    else if ((ydif == 0 && xdif == -1))
                    {//the enemy is to the  WEST
                        turn(direction.WEST);
                    }
                    else if ((ydif == 1 && xdif == 0))
                    {//the enemy is to the SOUTH
                        turn(direction.SOUTH);
                    }
                    else if ((ydif == -1 && xdif == 0))
                    {//the enemy is to the NORTH
                        turn(direction.NORTH);
                    }
                    //add attack logic
                    this.attack(enemy);
                }
            }
            else
            {//if the player is not in range try to move in a random direction until you do move
                this.move(d, map);
            }
        }

        public override void attack(Creature enemy)
        {
            int xdif = enemy.XPOS - this.XPOS;
            int ydif = enemy.YPOS - this.YPOS;
            int damage = this.POWER - enemy.ARMOR;
            if (damage < 1)
            {
                damage = 1;
            }

            if (ydif == 0 && xdif == 1)
            {//the enemy is to the EAST
                if (this.FACE == direction.EAST)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == 0 && xdif == -1))
            {//the enemy is to the  WEST
                if (this.FACE == direction.WEST)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == 1 && xdif == 0))
            {//the enemy is to the SOUTH
                if (this.FACE == direction.SOUTH)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else if ((ydif == -1 && xdif == 0))
            {//the enemy is to the NORTH
                if (this.FACE == direction.NORTH)
                {
                    enemy.Currenthp -= damage;
                }
            }
            else 
            { 
            }
        }
        public override void turn(direction d)
        {
            FACE = d;
            if (d == direction.WEST)
            {
                monsterpic = monsterpic4;
            }
            else if (d == direction.EAST)
            {
                monsterpic = monsterpic3;
            }
            else if (d == direction.SOUTH)
            {
                monsterpic = monsterpic1;
            }
            else if (d == direction.NORTH)
            {
                monsterpic = monsterpic2;
            }
            else
            {
                monsterpic = monsterpic;
            }
        }
    }

}